Type asteroid
	Field p.point[32]
	Field pCount
	
	Field vX#
	Field vY#
	Field vPhi#
End Type

Type point
	Field x#
	Field y#
End Type

Function newAsteroid.asteroid()
	a.asteroid=New asteroid
	Return a
End Function

Function newPoint.point(x#,y#)
	p.point=New point
	
	p\x=x
	p\y=y
	
	Return p
End Function

Function addPoint(a.asteroid,x#,y#)
	a\p[a\pCount]=newPoint(x,y)
	a\pCount=a\pCount+1
End Function

Function setSpeed(a.asteroid,x#,y#,phi#)
	a\vX=x
	a\vY=y
	a\vPhi=phi
End Function

Function pointInAsteroid(a.asteroid,x#,y#)
	If a=Null
		Return
	EndIf
	
	in = False
	
	For i=0 To a\pCount-1
		If i Then j=i-1 Else j=a\pCount-1
		x1#=a\p[i]\x
		y1#=a\p[i]\y
		x2#=a\p[j]\x
		y2#=a\p[j]\y
		If ((((y1<=y) And (y<y2)) Or ((y2<=y) And (y<y1))) And (x<(((x2-x1)*(y-y1))/(y2-y1))+x1))
			in = Not in
		EndIf
	Next
	
	Return in
End Function

Function reset()
	While ChannelPlaying(deathChan)
		updateAsteroids()
		updateShots()
		drawPlayer()
	Wend
	
	playerX=0
	playerY=0
	playerPhi=0
	playerV=0
	hitCounter=0
	blocked=True
	
	Delete Each asteroid
	Delete Each point
	Delete Each shot
	
	;For i=0 To 100
	;	a.asteroid=newAsteroid()
	;	mx#=Rnd(-1500,1500)
	;	my#=Rnd(-1500,1500)
	;	phi#=0
	;	For n=0 To Rand(5,10)
	;		r#=Rnd(50,80)
	;		phi#=phi+Rnd(10,36)
	;		addPoint(a,mx+Sin(phi)*r,my-Cos(phi)*r)
	;	Next
	;	setSpeed(a,Rnd(-3,3),Rnd(-3,3),Rnd(-3,3))
	;Next
End Function

Function updateGame()
	Local nbr=25
	
	For i=0 To nbr
		a.asteroid=newAsteroid()
		mx#=playerX+Cos(360./nbr*i+Rnd(-5,5))*500
		my#=playerY+Sin(360./nbr*i+Rnd(-5,5))*500
		
		phi#=0
		anzPoint=Rand(5,10)
		For n=0 To anzPoint
			r#=Rnd(50,80)
			phi#=phi+Rnd(10,36)
			addPoint(a,mx+Sin(phi)*r,my-Cos(phi)*r)
		Next
		
		vx#=mx-playerX
		vy#=my-playerY
		
		vl#=Sqr(vx*vx+vy*vy)
		vx=vx/vl
		vy=vy/vl
		
		setSpeed(a,vx+Rnd(-3,3),vy+Rnd(-3,3),Rnd(-3,3))
	Next
End Function

Type shot
	Field time
	
	Field x#
	Field y#
	
	Field vx#
	Field vy#
End Type

Function newShot()
	tmpChan=PlaySound(laserSound)
	ChannelVolume(tmpChan,.01)
	
	s.shot=New shot
	
	s\time=MilliSecs()
	
	s\x=playerX+Sin(playerPhi)*50
	s\y=playerY-Cos(playerPhi)*50
	
	s\vx=Sin(playerPhi)*(playerV+1.5)
	s\vy=-Cos(playerPhi)*(playerV+1.5)
End Function

Function updateShots()
	For s.shot=Each shot
		s\x=s\x+s\vx
		s\y=s\y+s\vy
		
		Rect s\x-playerX-3,s\y-playerY-3,6,6
		
		If MilliSecs()-s\time>10000
			Delete s
		EndIf
	Next
End Function

;Function drawShots()
;	For s.shot=Each shot
;		Rect s\x-playerX-3,s\y-playerY-3,6,6
;	Next
;End Function

Function updateAsteroids()
	For a.asteroid=Each asteroid
		smallestX#=1000000
		smallestY#=1000000
		biggestX#=-1000000
		biggestY#=-1000000
		For i=0 To a\pCount-1
			x1#=a\p[i]\x-playerX
			y1#=a\p[i]\y-playerY
			
			x2#=a\p[(i+1) Mod a\pCount]\x-playerX
			y2#=a\p[(i+1) Mod a\pCount]\y-playerY
			
			Line x1,y1,x2,y2
			
			If a\p[i]\x<smallestX
				smallestX=a\p[i]\x
			EndIf
			If a\p[i]\x>biggestX
				biggestX=a\p[i]\x
			EndIf
			If a\p[i]\y<smallestY
				smallestY=a\p[i]\y
			EndIf
			If a\p[i]\y>biggestY
				biggestY=a\p[i]\y
			EndIf
		Next
		
		mx#=0
		my#=0
		For i=0 To a\pCount-1
			mx=mx+a\p[i]\x
			my=my+a\p[i]\y
		Next
		mx=mx/a\pCount+a\vx
		my=my/a\pCount+a\vy
		
		For i=0 To a\pCount-1
			a\p[i]\x=a\p[i]\x+a\vx
			a\p[i]\y=a\p[i]\y+a\vy
			
			vx#=a\p[i]\x-mx
			vy#=a\p[i]\y-my
			
			dx#=Sin(a\vPhi)*vy+Cos(a\vPhi)*vx
			dy#=Cos(a\vPhi)*vy-Sin(a\vPhi)*vx
			
			a\p[i]\x=mx+dx
			a\p[i]\y=my+dy
		Next
		
		;lsche zu kleine asteroiden
		If Sqr((biggestX-smallestX)^2+(biggestY-smallestY)^2)<5
			Delete a
		EndIf
		
		;split asteroid
		If a<>Null
			For s.shot=Each shot
				If pointInAsteroid(a,s\x,s\y)
					;split it and quit it
					splitAsteroid(a,s\x,s\y)
					Delete s
				EndIf
			Next
		EndIf
		
		If a<>Null
			;hitdetection
			vx#=0
			vy#=50
			
			dx#=Sin(playerPhi)*vy+Cos(playerPhi)*vx
			dy#=Cos(playerPhi)*vy-Sin(playerPhi)*vx
			
			x1#=dx+playerX
			y1#=-dy+playerY
			
			vx#=-15
			vy#=-15
			
			dx#=Sin(playerPhi)*vy+Cos(playerPhi)*vx
			dy#=Cos(playerPhi)*vy-Sin(playerPhi)*vx
			
			x2#=dx+playerX
			y2#=-dy+playerY
			
			vx#=15
			vy#=-15
			
			dx#=Sin(playerPhi)*vy+Cos(playerPhi)*vx
			dy#=Cos(playerPhi)*vy-Sin(playerPhi)*vx
			
			x3#=dx+playerX
			y3#=-dy+playerY
			
			;If pointInAsteroid(a,x1,y1) Or pointInAsteroid(a,x2,y2) Or pointInAsteroid(a,x3,y3)
			;	reset()
			;EndIf
			If crossAsteroidPlayer(a)
				reset()
				
				Return
			EndIf
		EndIf
	Next
End Function

Function crossAsteroidPlayer(a.asteroid)
	Local px#[2]
	Local py#[2]
	
	vx#=0
	vy#=50
	
	dx#=Sin(playerPhi)*vy+Cos(playerPhi)*vx
	dy#=Cos(playerPhi)*vy-Sin(playerPhi)*vx
	
	px[0]=dx
	py[0]=-dy
	
	vx#=-15
	vy#=-15
	
	dx#=Sin(playerPhi)*vy+Cos(playerPhi)*vx
	dy#=Cos(playerPhi)*vy-Sin(playerPhi)*vx
	
	px[1]=dx
	py[1]=-dy
	
	vx#=15
	vy#=-15
	
	dx#=Sin(playerPhi)*vy+Cos(playerPhi)*vx
	dy#=Cos(playerPhi)*vy-Sin(playerPhi)*vx
	
	px[2]=dx
	py[2]=-dy
	
	For i=0 To a\pCount-1
		x1#=a\p[i]\x-playerX
		y1#=a\p[i]\y-playerY
		
		x2#=a\p[(i+1) Mod a\pCount]\x-playerX
		y2#=a\p[(i+1) Mod a\pCount]\y-playerY
		
		For k=0 To 2
			If lineCross(x1,y1,x2-x1,y2-y1,px[k],py[k],px[(k+1) Mod 3]-px[k],py[(k+1) Mod 3]-py[k])
				;Mich nervt der explosionssound :/
				
				;If Not ChannelPlaying(deathChan)
				;	deathChan=PlaySound(deathSound)
				;EndIf
				
				Return True
			EndIf
		Next
	Next
	
	Return False
End Function

;Function lineCross(p1.point,v1.vector,p2.point,v2.vector)
Function lineCross(p1X#,p1Y#,v1X#,v1Y#,p2X#,p2Y#,v2X#,v2Y#)
	Local trash#=0.001
	If Abs(v1X-v2X)<trash And Abs(v1Y-v2Y)<trash
		Return False
	EndIf
	
	k#=(p1X*v1Y-p1Y*v1X+v1X*p2Y-v1Y*p2X)/(v2X*v1Y-v2Y*v1X)
	t#=(p1X*v2Y-p1Y*v2X+v2X*p2Y-v2Y*p2X)/(v2X*v1Y-v2Y*v1X)
	
	If k>0 And k<1 And t>0 And t<1
		Return True
	EndIf
	
	Return False
End Function

Function splitAsteroid(a.asteroid,x#,y#)
	hitCounter=hitCounter+1
	
	tmpChan=PlaySound(asteroidSound)
	ChannelVolume(tmpChan,.5)
	
	;kill small asteroids
	If a\pCount<=3
		For i=0 To a\pCount-1
			Delete a\p[i]
		Next
		Delete a
		Return
	EndIf
	
	;find next point
	Local pn.point
	Local pni
	Local smallestDist#=1000000
	For i=0 To a\pCount-1
		dist#=Sqr((x-a\p[i]\x)^2+(y-a\p[i]\y)^2)
		If dist<smallestDist
			smallestDist=dist
			pn=a\p[i]
			pni=i
		EndIf
	Next
	
	;now lets split :>
	For i=pni+1 To pni+a\pCount-2
		;ii=pni Mod a\pCount
		
		anew.asteroid=newAsteroid()
		addPoint(anew,a\p[pni]\x,a\p[pni]\y)
		addPoint(anew,a\p[i Mod a\pCount]\x,a\p[i Mod a\pCount]\y)
		addPoint(anew,a\p[(i+1) Mod a\pCount]\x,a\p[(i+1) Mod a\pCount]\y)
		;addPoint(anew,a\p[(i+2) Mod a\pCount]\x,a\p[(i+2) Mod a\pCount]\y)
		
		setSpeed(anew,Rnd(-3,3),Rnd(-3,3),Rnd(-3,3))
		
		i=i+1
	Next
	
	;clean up
	For i=0 To a\pCount-1
		Delete a\p[i]
	Next
	Delete a
End Function

;Function drawAsteroids()
;	For a.asteroid=Each asteroid
;		For i=0 To a\pCount-1
;			x1#=a\p[i]\x-playerX
;			y1#=a\p[i]\y-playerY
;			
;			x2#=a\p[(i+1) Mod a\pCount]\x-playerX
;			y2#=a\p[(i+1) Mod a\pCount]\y-playerY
;			
;			Line x1,y1,x2,y2
;		Next
;	Next
;End Function

Function drawPlayer()
	vx#=0
	vy#=50
	
	dx#=Sin(playerPhi)*vy+Cos(playerPhi)*vx
	dy#=Cos(playerPhi)*vy-Sin(playerPhi)*vx
	
	x1#=dx
	y1#=-dy
	
	vx#=-15
	vy#=-15
	
	dx#=Sin(playerPhi)*vy+Cos(playerPhi)*vx
	dy#=Cos(playerPhi)*vy-Sin(playerPhi)*vx
	
	x2#=dx
	y2#=-dy
	
	vx#=15
	vy#=-15
	
	dx#=Sin(playerPhi)*vy+Cos(playerPhi)*vx
	dy#=Cos(playerPhi)*vy-Sin(playerPhi)*vx
	
	x3#=dx
	y3#=-dy
	
	Line x1,y1,x2,y2
	Line x2,y2,x3,y3
	Line x3,y3,x1,y1
End Function

Global playerX#=0
Global playerY#=0
Global playerPhi#=0 ;uhrzeigersinn=+ , 0=oben
Global playerV#=0

Global hitCounter
Global blocked

Global laserSound=LoadSound("laser.ogg")
Global asteroidSound=LoadSound("asteroidExplosion.ogg")
Global deathSound=LoadSound("shipExplosion.ogg")
Global deathChan

reset()

Graphics 800,600,0,2
SetBuffer BackBuffer()
Origin 400,300

timer=CreateTimer(60)
While Not KeyHit(1)
	While blocked
		drawPlayer()
		
		Text -Len("Ready?")*4,0,"Ready?"
		
		For i=0 To 237
			If KeyDown(i)
				blocked=False
			EndIf
		Next
		lifeTime=MilliSecs()
		
		Flip 0
		Cls
	Wend
	
	updateAsteroids()
	;drawAsteroids()
	drawPlayer()
	
	Text -Len(hitCounter)*4,-290,hitCounter
	Text -Len("You lived for "+((MilliSecs()-lifeTime)/1000)+" seconds")*4,-270,"You lived for "+((MilliSecs()-lifeTime)/1000)+" seconds"
	
	playerPhi=playerPhi+(KeyDown(205)-KeyDown(203))
	playerV=playerV+(KeyDown(200)-KeyDown(208))*0.2-0.1
	If playerV>5
		playerV=5
	EndIf
	If playerV<0
		playerV=0
	EndIf
	playerX=playerX+Sin(playerPhi)*playerV
	playerY=playerY-Cos(playerPhi)*playerV
	
	If KeyDown(33)
		If MilliSecs()-shotTime>50
			newShot()
			shotTime=MilliSecs()
		EndIf
	EndIf
	updateShots()
	;drawShots()
	
	If MilliSecs()-spawnTime>1500
		updateGame()
		
		spawnTime=MilliSecs()
	EndIf
	
	Flip 0
	Cls
	WaitTimer(timer)
Wend
End
;~IDEal Editor Parameters:
;~C#Blitz3D