;************************
;
; Holzchopf - BCC #30 - Verlassen
;
;++++++++++++++++++++++++
; Releases:
;	17.10.2009	- v1b
;	17.10.2009	- v1c
;		Normale Zahlentasten hinzugefgt
;	17.10.2009	- v2
;		Neu mit Musik!
;************************

Const MODE_MENU=1
Const MODE_GAME=2
Const MODE_VICTORY=3
Const MODE_CHANGE=4
Global gMode=MODE_MENU
Global gChangeTime

Const MOVETIME=400
Const CHANGETIME=200

Type TPlayer
	Field x,y,a,f,mv,nx,ny,mt,px,py,i
	Field Action[9]
End Type
Global plr.TPlayer=New TPlayer

; Level
Type TLevel
	Field GlobalStates
	Field RoomList
	Field StartRoom,StartX,StartY
	Field Room.TRoom
End Type
Global gLevel.TLevel
; Raum
Type TRoom
	Field Map
	Field ScriptLines,ScriptBuffer
End Type
; Tilesets
Dim imgTileset(3)
; Frames
Dim FrameWalkable(240)

; Meldungen
Type TMessage
	Field txt$
End Type
; Inventar
Type TInventory
	Field img
	Field Name$
	Field picked
End Type
Global gInventory.TInventory[8]

Global gScriptPointer

;************************
; "Main" ;)
Graphics 320, 240, 0, 2
AppTitle "Holzchopf - Verlassen"
SetBuffer BackBuffer()
Global TIMER = CreateTimer(30)

Global imgTitel=LoadImage("gfx/titel.png")
Global imgFigure=LoadAnimImage("gfx/figur.png",18,34,0,12)
MaskImage imgFigure,255,0,255
Global imgFont=LoadAnimImage("gfx/font.png",8,12,0,96)
Global imgInventory=LoadImage("gfx/inventar.png")

LoadLevel("lvl/ship.lvl")

Local chnlMusic,plMusic=1
Global MSec
Repeat
	Cls
	MSec = MilliSecs()
	
	If gMode=MODE_MENU Menu()
	If gMode=MODE_GAME Game()
	If gMode=MODE_VICTORY Victory()
	If gMode=MODE_CHANGE Change()
	
	If KeyHit(50)
		If plMusic StopChannel chnlMusic
		plMusic=1-plMusic
	EndIf
	If (Not ChannelPlaying(chnlMusic)) And plMusic
		chnlMusic=PlayMusic("snd/soundtrack.ogg")
	EndIf
	
	Flip 0
	WaitTimer(TIMER)
Forever

;************************
; Funktionen
Function Menu()
	DrawImage imgTitel,0,0
	If KeyHit(1) End
	If KeyHit(57) gMode=MODE_GAME
	
	DrawText "Steuerung:",0,120
	DrawText "  Bewegen                Pfeiltasten",0,132
	DrawText "  Aktion                 Leertaste",0,144
	DrawText "  Gegenstand benutzen    Ziffernblock",0,156
	
	DrawText "Musik ein/aus:           M",0,180

	DrawText "Beenden:  <Esc> druecken",0,204
	DrawText "Starten:  <Leertaste> druecken",0,228
End Function
Function Game()
	Local Message.TMessage
	Local i,x#,y#,f#,ix,iy,fr

	If KeyHit(1) gMode=MODE_MENU
	
	; Aktionen
	plr\Action[0]=KeyHit(57)
	For i=0 To 8
		plr\Action[i+1]=(KeyHit(79-4*(i/3)+(i Mod 3))=1 Or KeyHit(2+i)) And gInventory[i]\picked=True
	Next

	; Bewegung
	If MSec=>plr\mt
		plr\mv=0
		plr\x=plr\x+plr\nx
		plr\y=plr\y+plr\ny
	EndIf

	If plr\mv=0
		plr\nx=0
		plr\ny=0
		If KeyDown(200)
			plr\a=0
			plr\ny=-1
			plr\mv=1
		ElseIf KeyDown(208)
			plr\a=2
			plr\ny=+1
			plr\mv=1
		ElseIf KeyDown(203)
			plr\a=1
			plr\nx=-1
			plr\mv=1
		ElseIf KeyDown(205)
			plr\a=3
			plr\nx=+1
			plr\mv=1
		EndIf
		If plr\mv plr\mt=MSec+MOVETIME
	EndIf
	f=0
	plr\i=0
	If plr\mv
		f=1-(plr\mt-MSec)/Float(MOVETIME)
		If f>1 Then f=1
		plr\i=Floor(f*4)
	EndIf
	x=plr\x+plr\nx*f
	y=plr\y+plr\ny*f
	plr\px=fx(x,y)
	plr\py=fy(x,y)
	plr\f=(plr\i Mod 2)*(plr\i+1)/2

	; Kollisionskontrolle
	ix=plr\x+plr\nx
	iy=plr\y+plr\ny
	If ix=>0 And ix<10 And iy=>0 And iy<10
		fr=PeekByte(gLevel\Room\Map,iy*10+ix)
		If fr<255
			If Not FrameWalkable(fr)
				plr\nx=0
				plr\ny=0
				plr\mv=0
			EndIf
		EndIf
	EndIf

	RunScripts()
	
	DrawMap()
	DrawInventory()
	
	y=228
	Message=Last TMessage
	While Message<>Null
		DrawText(Message\txt,0,y)
		y=y-12
		Message=Before Message
	Wend

End Function
Function Victory()
	DrawImage imgTitel,0,0
	If KeyHit(57) gMode=MODE_MENU
	
	DrawText "      Mission erfolgreich beendet!",0,144

	DrawText "Weiter:  <Leertaste> druecken",0,228
End Function
Function Change()
	If MSec=>gChangeTime gMode=MODE_GAME
	FlushKeys()
	DrawInventory()
End Function


Function LoadLevel(pName$)
	Local i,offset,Room.TRoom,cnt
	; init
	gLevel=New TLevel
	gLevel\RoomList=CreateBank()
	; laden
	Local FileStream=ReadFile(pName)
	; Tilesets
	For i=0 To 3
		imgTileset(i)=LoadAnimImage("gfx/"+ReadLine(FileStream),30,71,0,60)
		If imgTileset(i)<>0 MaskImage imgTileset(i),255,0,255
	Next
	; Anzahl Global States
	gLevel\GlobalStates=CreateBank(ReadInt(FileStream)*4)
	; Global States auslesen
	ReadBytes(gLevel\GlobalStates,FileStream,0,BankSize(gLevel\GlobalStates))
	; Inventar
	For i=0 To 8
		gInventory[i]=New TInventory
		gInventory[i]\img=LoadImage("gfx/"+ReadLine(FileStream))
		If gInventory[i]\img MaskImage gInventory[i]\img,255,0,255
		gInventory[i]\Name=ReadLine(FileStream)
	Next
	; Startposition
	gLevel\StartRoom=ReadInt(FileStream)
	gLevel\StartX=ReadByte(FileStream)
	gLevel\StartY=ReadByte(FileStream)
	; Frames
	For i=0 To 239
		FrameWalkable(i)=ReadByte(FileStream)
	Next
	; Rume
	While Not Eof(FileStream)
		; Raum eintragen
		Room=New TRoom
		Room\Map=CreateBank(100)
		offset=BankSize(gLevel\RoomList)
		ResizeBank(gLevel\RoomList,offset+4)
		PokeInt(gLevel\RoomList,offset,Handle(Room))
		; Geometrie
		ReadBytes(Room\Map,FileStream,0,100)
		; Scripts (Zeilen)
		cnt=ReadInt(FileStream)
		Room\ScriptLines=CreateBank(cnt)
		ReadBytes(Room\ScriptLines,FileStream,0,cnt)
		; Scripts (Befehle)
		cnt=ReadInt(FileStream)
		Room\ScriptBuffer=CreateBank(cnt)
		ReadBytes(Room\ScriptBuffer,FileStream,0,cnt)
	Wend
	CloseFile FileStream
	; Startwerte setzen
	gLevel\Room=Object.TRoom(PeekInt(gLevel\RoomList,gLevel\StartRoom*4))
	plr\x=gLevel\StartX
	plr\y=gLevel\StartY
End Function


Function DrawMap()
	If gMode=MODE_CHANGE Return
	Local ix,iy,iz,fr,px,py

	px=plr\x+(plr\nx>0)
	py=plr\y+(plr\ny>0)
	; shit unterhalb spieler
	For iy=0 To 9
		For ix=0 To 9
			If ix<=px And iy<=py
				fr=PeekByte(gLevel\Room\Map,iy*10+ix)
				If fr<255
					DrawImage imgTileset(fr/60), fx(ix,iy), fy(ix,iy), fr Mod 60
				EndIf
			EndIf
		Next
	Next
	; Spieler
	DrawImage imgFigure,plr\px+6,plr\py+15,plr\a+4*plr\f
	; shit, der Spieler verdecken tut
	For iy=0 To 9
		For ix=0 To 9
			If ix>px Or iy>py
				fr=PeekByte(gLevel\Room\Map,iy*10+ix)
				If fr<255
					DrawImage imgTileset(fr/60), fx(ix,iy), fy(ix,iy), fr Mod 60
				EndIf
			EndIf
		Next
	Next
End Function
Function fx(x#,y#)
	Return 118 +18 *x -12 *y
End Function
Function fy(x#,y#)
	Return 10 +12 *y +6 *x
End Function

Function DrawInventory()
	Local ix,iy
	For iy=0 To 2
		For ix=0 To 2
			If gInventory[iy*3+ix]\picked=True And gInventory[iy*3+ix]\img<>0 DrawImage gInventory[iy*3+ix]\img,ix*20+2,40-iy*20+2
		Next
	Next
	DrawImage imgInventory,0,0
End Function


Function RunScripts()
	Local iScript,operation,px,py,pp,pa,ptxt$,i
	Local nRoom.TRoom,Message.TMessage
	; alle zeilen durchgehen
	If BankSize(gLevel\Room\ScriptLines)=0 Return
	Repeat
		; zeile starten
		gScriptPointer=PeekInt(gLevel\Room\ScriptLines,iScript*4)
		iScript=iScript+1
		operation=GetOperation()
		; Befehl ausfhren
		Select operation
		Case $00	; Victory
			gMode=MODE_VICTORY
			Exit
		Case $10	; OnTouch
			px=GetByteParam()
			py=GetByteParam()
			pp=GetIntParam()
			If Abs(plr\x-px)<2 And Abs(plr\y-py)<2 And (plr\x=px Or plr\y=py) iScript=pp
		Case $11	; OnLeaveNorth
			px=GetByteParam()
			py=GetByteParam()
			pp=GetIntParam()
			If plr\x=px And plr\y=py And plr\ny<0 And plr\i>1 iScript=pp
		Case $12	; OnLeaveWest
			px=GetByteParam()
			py=GetByteParam()
			pp=GetIntParam()
			If plr\x=px And plr\y=py And plr\nx<0 And plr\i>1 iScript=pp
		Case $13	; OnLeaveSouth
			px=GetByteParam()
			py=GetByteParam()
			pp=GetIntParam()
			If plr\x=px And plr\y=py And plr\ny>0 And plr\i>1 iScript=pp
		Case $14	; OnLeaveEast
			px=GetByteParam()
			py=GetByteParam()
			pp=GetIntParam()
			If plr\x=px And plr\y=py And plr\nx>0 And plr\i>1 iScript=pp
		Case $15	; OnEnter
			px=GetByteParam()
			py=GetByteParam()
			pp=GetIntParam()
			If plr\x+plr\nx=px And plr\y+plr\ny=py And plr\i>1 iScript=pp
		Case $16	; OnStand
			px=GetByteParam()
			py=GetByteParam()
			pp=GetIntParam()
			If plr\x=px And plr\y=py iScript=pp
		Case $17	; OnAction
			px=GetByteParam()
			py=GetByteParam()
			pa=GetByteParam()
			pp=GetIntParam()
			If plr\x=px+(plr\a=1)-(plr\a=3) And plr\y=py+(plr\a=0)-(plr\a=2) And plr\Action[pa]=1 iScript=pp
		Case $20	; SetTile
			px=GetByteParam()
			py=GetByteParam()
			pp=GetByteParam()
			PokeByte(gLevel\Room\Map,py*10+px,pp)
		Case $30	; ChangeRoom
			pp=GetIntParam()
			nRoom=Object.TRoom(PeekInt(gLevel\RoomList,pp*4))
		Case $31	; MovePlayer
			plr\x=GetByteParam()
			plr\y=GetByteParam()
			plr\nx=0
			plr\ny=0
		Case $32	; RotatePlayer
			plr\a=GetByteParam()
		Case $40	; OnFace
			px=GetByteParam()
			pp=GetIntParam()
			If plr\a=px iScript=pp
		Case $50	; SetGlobal
			pp=GetIntParam()
			pa=GetIntParam()
			PokeByte(gLevel\GlobalStates,pp*4,pa)
		Case $51	; IfGlobal
			pa=GetIntParam()
			px=GetIntParam()
			pp=GetIntParam()
			If PeekInt(gLevel\GlobalStates,pa*4)=px iScript=pp
		Case $60	; SetTime
			pp=GetIntParam()
			pa=GetIntParam()
			PokeInt(gLevel\GlobalStates,pp*4,MSec+pa)
		Case $61	; IfTimeElapsed
			pa=GetIntParam()
			pp=GetIntParam()
			If MSec=>PeekInt(gLevel\GlobalStates,pa*4) iScript=pp
		Case $70	; Pick
			pa=GetByteParam()
			gInventory[pa]\picked=True
			Message=New TMessage
			Message\txt="<"+gInventory[pa]\Name+" erhalten>"
		Case $71	; IfPicked
			pa=GetByteParam()
			pp=GetIntParam()
			If gInventory[pa]\picked>0 iScript=pp
		Case $7F	; Drop
			pa=GetByteParam()
			gInventory[pa]\picked=2
			Message=New TMessage
			Message\txt="<"+gInventory[pa]\Name+" abgelegt>"
		Case $E0	; Say
			pa=GetByteParam()
			ptxt=""
			For i=1 To pa
				ptxt=ptxt+Chr(GetByteParam())
			Next
			Message=New TMessage
			Message\txt=ptxt
		Case $E1	; Clear
			For Message=Each TMessage
				Delete Message
			Next
		Case $F0	; Goto
			pp=GetIntParam()
			iScript=pp
		Case $FF	; End
			Exit
		End Select
	Until iScript=BankSize(gLevel\Room\ScriptLines)/4
	If nRoom<>Null
		gLevel\Room=nRoom
		For Message=Each TMessage
			Delete Message
		Next
		gChangeTime=MSec+CHANGETIME
		gMode=MODE_CHANGE
	EndIf
End Function
Function GetOperation()
	gScriptPointer=gScriptPointer+1
	Return PeekByte(gLevel\Room\ScriptBuffer,gScriptPointer-1)
End Function
Function GetByteParam()
	gScriptPointer=gScriptPointer+1
	Return PeekByte(gLevel\Room\ScriptBuffer,gScriptPointer-1)
End Function
Function GetIntParam()
	gScriptPointer=gScriptPointer+4
	Return PeekInt(gLevel\Room\ScriptBuffer,gScriptPointer-4)
End Function

Function DrawText(pTxt$,pX,pY)
	Local c,a
	For a=1 To Len(pTxt)
		c=Asc(Mid(pTxt,a,1))
		If c>31 DrawBlock imgFont,pX+(a-1)*8,pY,c-32
	Next
End Function


;~IDEal Editor Parameters:
;~C#Blitz3D