
SuperStrict

Framework BRL.GLMax2D

Import BRL.Random

Import BRL.Math

Import BRL.Timer

Import BRL.PNGLoader

Import BRL.RAMStream

Import BRL.Retro

Type TWall
	
	Field height:Int
	
	Field tile:Int
	
	Field r:Int,g:Int,b:Int
	
EndType

AppTitle = "Raycaster"

SetGraphicsDriver GLMax2DDriver()

Local fullscreen:Int = Proceed("Vollbild?")

If fullscreen = 1
	
	Graphics(320,240,32)
	
	HideMouse()
	
ElseIf fullscreen = -1

	End

Else

	Graphics(320,240)

EndIf

Local timer:TTimer = CreateTimer(60)

Local x:Float, y:Float

Local MapWidth:Int = 20, MapHeight:Int = 20

Global OldMouseX:Int, OldMouseY:Int

Incbin "Tile1.png"

Incbin "Tile2.png"

Incbin "Tile3.png"

Incbin "floor.png"

Local tile1:TImage = LoadImage("incbin::Tile1.png")

Local tile2:TImage = LoadImage("incbin::Tile2.png")

Local tile3:TImage = LoadImage("incbin::Tile3.png")

Local tile_slices:TImage[64,6]

DrawImage(tile1,0,0)

For Local i:Int = 0 To 63
	
	tile_slices[i,1] = CreateImage(1,64)
	
	GrabImage(tile_slices[i,1],i,0)
	
Next

DrawImage(tile2,0,0)

For Local i:Int = 0 To 63
	
	tile_slices[i,2] = CreateImage(1,64)
	
	GrabImage(tile_slices[i,2],i,0)
	
Next

DrawImage(tile3,0,0)

For Local i:Int = 0 To 63
	
	tile_slices[i,3] = CreateImage(1,64)
	
	GrabImage(tile_slices[i,3],i,0)
	
Next


Local floor_img:TImage = LoadImage("incbin::floor.png")

Local map:TWall[MapWidth,MapHeight]

RestoreData Level

For x = 0 Until MapWidth
	
	For y = 0 Until MapHeight
		
		map[x,y] = New TWall
		
		ReadData map[x,y].tile
		
		map[x,y].r = Rand(255)
		
		map[x,y].g = Rand(255)
		
		map[x,y].b = Rand(255)
		
		
	Next

Next

Local xp:Float = 1.5, yp:Float = 18.5, FOV:Float = 5, ppitch:Float = 0, pyaw:Float = 0

Local pryaw:Float = 0

Local Dist:Float

Local FPS:Int, FrameC:Int, FPSTimer:Int = MilliSecs(), ticks:Int

Repeat
	
	If KeyDown(KEY_W) And map[xp + Cos(pyaw-30)/24.0, yp + Sin(pyaw-30)/24.0].tile = 0
	
		xp = xp + Cos(pyaw-30)/24.0
	
		yp = yp + Sin(pyaw-30)/24.0
	
	EndIf
	
	If KeyDown(KEY_S) And map[xp - Cos(pyaw-45)/24.0,yp - Sin(pyaw-45)/24.0].tile = 0
	
		xp = xp - Cos(pyaw-45)/24.0
	
		yp = yp - Sin(pyaw-45)/24.0
	
	EndIf
	
	If KeyDown(KEY_A)
	
		xp = xp - Cos(pyaw-135)/48.0
	
		yp = yp - Sin(pyaw-135)/48.0
	
	EndIf
	
	If KeyDown(KEY_D)
	
		xp = xp + Cos(pyaw-135)/48.0
	
		yp = yp + Sin(pyaw-135)/48.0
	
	EndIf
	
	ppitch = ppitch + MouseYSpeed()*-1
	
	If ppitch > 240 ppitch = 240
	
	If ppitch < -80 ppitch = -80
	
	pyaw = pyaw + MouseXSpeed()*-1
	
	MoveMouse 160,120
	
	MouseXSpeed()
	
	MouseYSpeed()
	
	Local RayAngle:Double = pyaw-FOV/2.0
	
	Local DeltaAngle:Double = FOV/320.0
	
	For x = 0 To 320 Step 2
	
		SetScale 1,1
		
		SetColor 255,255,255
		
		'DrawRect x,ppitch+10,2,480
		
		DrawImage floor_img,x,ppitch+10
		
		For dist = 0 To 10 Step 0.02
			
			Local clr:Int = 255-Dist*25
			
			If clr < 0 clr = 0
			
			SetColor clr,clr,clr
			
			Local map_x:Float = xp+Cos(pyaw-x/FOV)*dist
			
			Local map_y:Float = yp+Sin(pyaw-x/FOV)*dist
			
			If map[map_x,map_y].tile > 0
			
				'DrawRect x,ppitch-map[map_x,map_y].height*100.0/dist,1,map[map_x,map_y].height*200.0/Dist
				
				SetScale 2,(200.0/(Dist*Cos((pyaw-RayAngle))))/64.0
				
				If map_x-0.05 > Int(map_x) And ((map_x+0.05 > Ceil(map_x)) = 0)
				
					DrawImage tile_slices[Int((map_x-Int(map_x))*63.0),map[map_x,map_y].tile], x, ppitch-100/Dist
				
				Else
				
					DrawImage tile_slices[Int((map_y-Int(map_y))*63.0),map[map_x,map_y].tile], x, ppitch-100/Dist
				
				EndIf
				
				Exit
			
			EndIf
		
		Next
		
		RayAngle = RayAngle + DeltaAngle
	
	Next
	
	
	SetScale 1,1
	
	SetColor 255,255,255
	
	DrawText("FPS: "+fps+" | PYAW: "+pyaw,0,0)
	
	DrawOval MouseX()-1, MouseY()-1, 2, 2
	
	Flip 0
	
	Cls
	
	ticks = WaitTimer(timer)
	
	FrameC = FrameC + 1
	
	If MilliSecs()-FPSTimer > 999
	
		FPS = FrameC
		
		FrameC = 0
		
		FPSTimer = MilliSecs()
	
	EndIf

Until KeyHit(KEY_ESCAPE) Or AppTerminate()


#Level
DefData 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
DefData 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DefData 1,0,2,0,1,1,1,1,1,1,2,0,2,0,0,0,0,0,0,1
DefData 1,0,0,0,1,0,0,0,0,0,0,0,2,0,0,2,0,0,0,1
DefData 1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,1,0,0,0,1
DefData 1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,2,2,2,0,1
DefData 1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,1
DefData 1,0,0,2,0,0,0,2,2,2,2,2,2,0,0,2,0,0,0,1
DefData 1,0,0,0,0,0,0,2,0,0,0,0,2,1,1,1,1,1,1,1
DefData 1,0,0,2,0,0,0,0,0,3,3,0,0,0,0,0,0,0,0,1
DefData 1,0,0,0,0,0,0,0,0,3,3,0,0,0,0,0,0,0,0,1
DefData 1,0,0,2,0,0,0,2,0,0,0,0,2,1,1,1,1,1,0,1
DefData 1,0,0,0,0,0,0,2,2,0,0,2,2,0,0,0,0,2,0,1
DefData 1,0,0,0,0,0,0,0,2,0,0,2,0,0,0,1,0,2,0,1
DefData 1,0,0,0,0,0,1,0,2,0,0,2,0,2,0,1,0,2,0,1
DefData 1,0,0,0,0,0,1,0,2,0,0,2,0,2,0,1,0,2,0,1
DefData 1,0,0,0,0,0,1,0,2,0,0,2,0,2,0,0,0,2,0,1
DefData 1,0,0,0,0,0,1,1,2,0,0,2,0,2,2,2,2,2,0,1
DefData 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DefData 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1


Function MouseXSpeed:Int()
	
	Local MXSpeed:Int = MouseX()-OldMouseX
	
	OldMouseX = MouseX()
	
	Return MXSpeed

EndFunction

Function MouseYSpeed:Int()
	
	Local MYSpeed:Int = MouseY()-OldMouseY
	
	OldMouseY = MouseY()
	
	Return MYSpeed

EndFunction
